commit 51a56a51b00bd3f5f92b5bc498930e48e0334a0e
Author: freddy77 <freddy77>
Date:   Wed Mar 11 09:07:33 2009 +0000

    avoid memory corruption on out of memory

diff --git a/ChangeLog b/ChangeLog
index b62e5ab..d47e6ae 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Mar 11 10:07:02 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/bcp.c: avoid memory corruption on out of memory
+
 Mon Mar  9 21:53:46 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* TODO.freddy src/odbc/unittests/genparams.c: add test for binary
 
@@ -1395,4 +1398,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2747 2009/03/09 20:53:53 freddy77 Exp $
+$Id: ChangeLog,v 1.2748 2009/03/11 09:07:33 freddy77 Exp $
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 6f686f7..da2a3e5 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.182 2009/03/02 05:39:45 jklowden Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.183 2009/03/11 09:07:33 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -388,6 +388,7 @@ bcp_colfmt(DBPROCESS * dbproc, int host_colnum, int host_type, int host_prefixle
 	   int host_termlen, int table_colnum)
 {
 	BCP_HOSTCOLINFO *hostcol;
+	BYTE *terminator = NULL;
 
 	tdsdump_log(TDS_DBG_FUNC, "bcp_colfmt(%p, %d, %d, %d, %d, %p)\n", 
 		    dbproc, host_colnum, host_type, host_prefixlen, (int) host_collen, host_term);
@@ -450,18 +451,19 @@ bcp_colfmt(DBPROCESS * dbproc, int host_colnum, int host_type, int host_prefixle
 	hostcol = dbproc->hostfileinfo->host_columns[host_colnum - 1];
 
 	/* TODO add precision scale and join with bcp_colfmt_ps */
-	hostcol->host_column = host_colnum;
-	hostcol->datatype = host_type;
-	hostcol->prefix_len = host_prefixlen;
-	hostcol->column_len = host_collen;
-	if (host_term && host_termlen >= 0) {
-		free(hostcol->terminator);
-		if ((hostcol->terminator = malloc(host_termlen)) == NULL) {
+	if (host_term && host_termlen > 0) {
+		if ((terminator = malloc(host_termlen)) == NULL) {
 			dbperror(dbproc, SYBEMEM, errno);
 			return FAIL;
 		}
-		memcpy(hostcol->terminator, host_term, host_termlen);
+		memcpy(terminator, host_term, host_termlen);
 	}
+	hostcol->host_column = host_colnum;
+	hostcol->datatype = host_type;
+	hostcol->prefix_len = host_prefixlen;
+	hostcol->column_len = host_collen;
+	free(hostcol->terminator);
+	hostcol->terminator = terminator;
 	hostcol->term_len = host_termlen;
 	hostcol->tab_colnum = table_colnum;
 

